<template>
  <form @submit.prevent="addDocument">
    <AtomSelect
      label="Type de fichier"
      name="document_type"
      :options="DOCUMENT_TYPE_OPTIONS"
      required
    />
    <!-- FIXME: Arrow navigation is not working due to DSFR - See https://github.com/GouvernementFR/dsfr/issues/517 -->
    <AtomSearchableSelect
      label="Thèmes"
      name="labels"
      :options="DOCUMENT_THEME_OPTIONS"
      multiple
    />
    <AtomCheckbox
      class="fr-mb-2w"
      label="Confidentiel"
      name="confidential"
    />
    <AtomUpload
      label="Ajouter un fichier"
      name="file"
      accept="application/pdf, image/*, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel, application/vnd.oasis.opendocument.spreadsheet, application/msword, application/vnd.openxmlformats-officedocument.wordprocessingml.document, application/vnd.oasis.opendocument.text"
      required
    />
    <button
      class="fr-btn fr-mt-3w"
      title="Ajouter"
      type="submit"
      :submitting="isSubmitting"
    >
      Ajouter
    </button>
  </form>
</template>

<script setup>
  import { checkboxValuesToBoolean } from '~/utils'
  import {
    DOCUMENT_TYPE_OPTIONS,
    DOCUMENT_THEME_OPTIONS
  } from '~/utils/constants/document'
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { dataObjectFromForm, formFromEvent } from '~/utils/formData'

  const { $apiRequest, $snackbar, $modal } = useNuxtApp()

  const props = defineProps({
    beneficiaryDocumentFolderId: { type: String, required: true },
    beneficiaryId: { type: String, required: true }
  })

  const emit = defineEmits(['added'])

  const isSubmitting = ref(false)

  async function addDocument(event) {
    const CHECKBOX_KEYS = ['confidential']
    isSubmitting.value = true
    const form = formFromEvent(event)
    const documentData = checkboxValuesToBoolean(
      dataObjectFromForm(form),
      CHECKBOX_KEYS
    )
    const formData = new FormData()
    if (documentData.labels.length) {
      // use a Blob because labels must be sent as an application/json type within the multipart/form-data request
      formData.append(
        'labels',
        new Blob([JSON.stringify(documentData.labels.split(','))], {
          type: 'application/json'
        }),
        ''
      )
    }
    formData.append('folder', props.beneficiaryDocumentFolderId)
    formData.append('beneficiary', props.beneficiaryId)
    formData.append('document_type', documentData.document_type)
    formData.append('confidential', documentData.confidential)
    formData.append('file', documentData.file)
    try {
      const res = await $apiRequest('/files', {
        method: 'post',
        body: formData
      })

      if (res.status === 200) {
        emit('added', res.data.data)
        form.reset()
        $modal.close()
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error("L'envoi du fichier a échoué.")
    } finally {
      isSubmitting.value = false
    }
  }
</script>
